LeetCode 15 3Sum 解题思路和python代码

题目:
Given an integer array nums, return all the triplets [nums[i], nums[j], nums[k]] such that i != j, i != k, and j != k, and nums[i] + nums[j] + nums[k] == 0.

Notice that the solution set must not contain duplicate triplets.

Example 1:

Input: nums = [-1,0,1,2,-1,-4]
Output: [[-1,-1,2],[-1,0,1]]
Explanation:
nums[0] + nums[1] + nums[2] = (-1) + 0 + 1 = 0.
nums[1] + nums[2] + nums[4] = 0 + 1 + (-1) = 0.
nums[0] + nums[3] + nums[4] = (-1) + 2 + (-1) = 0.
The distinct triplets are [-1,0,1] and [-1,-1,2].
Notice that the order of the output and the order of the triplets does not matter.
Example 2:

Input: nums = [0,1,1]
Output: []
Explanation: The only possible triplet does not sum up to 0.
Example 3:

Input: nums = [0,0,0]
Output: [[0,0,0]]
Explanation: The only possible triplet sums up to 0.

Constraints:

3 <= nums.length <= 3000
-105 <= nums[i] <= 105

解题思路:
首先对数组进行排序,有助于使用双指针方法快速找到合适的三元组。
对于每个元素nums[i],将它作为第一个数,然后使用双指针方法在 i 之后的数组部分寻找另外两个数,使它们的和等于0。
左指针从 i+1 开始,右指针从数组末尾开始,逐步向中间收缩。根据三者之和的结果,调整左右指针的位置。
为了避免重复的三元组,遍历时需要跳过相同的元素。

class Solution(object):
    def threeSum(self, nums):
        """
        :type nums: List[int]
        :rtype: List[List[int]]
        """
        result = []
        nums.sort()

        print("nums: ", nums)

        for i in range(len(nums)):
            print("i: ", i)

            # 如果当前元素和前一个相同,跳过,避免重复三元组
            if i > 0 and nums[i] == nums[i-1]:
                continue
            
            left, right = i+1, len(nums)-1

            while left < right:
                print("nums[i]: ", nums[i])
                print("nums[left]: ", nums[left])
                print("nums[right]: ", nums[right])
                total = nums[i] + nums[left] + nums[right]
                print("total: ", total)

                if total == 0:
                    result.append([nums[i], nums[left], nums[right]])

                    while left < right and nums[left] == nums[left+1]:
                        left+=1
                    while left < right and nums[right] == nums[right-1]:
                        right-=1
                    
                    left+=1
                    right-=1
                
                elif total < 0:
                    left += 1
                else:
                    right -= 1
        
        return result

例子:
nums = [-1,0,1,2,-1,-4]

首先,对数组进行排序。
('nums: ', [-4, -1, -1, 0, 1, 2])

接着,遍历数组。
('i: ', 0)
('nums[i]: ', -4)
('nums[left]: ', -1)
('nums[right]: ', 2)
('total: ', -3)

和小于0,说明左指针太小,向右移动左指针。

('nums[i]: ', -4)
('nums[left]: ', -1)
('nums[right]: ', 2)
('total: ', -3)

和还是小于0,说明左指针太小,向右移动左指针。

('nums[i]: ', -4)
('nums[left]: ', 0)
('nums[right]: ', 2)
('total: ', -2)

和还是小于0,说明左指针太小,向右移动左指针。

('nums[i]: ', -4)
('nums[left]: ', 1)
('nums[right]: ', 2)
('total: ', -1)

和还是小于0,但 i=0 的遍历结束,进入 i=1。

('i: ', 1)
('nums[i]: ', -1)
('nums[left]: ', -1)
('nums[right]: ', 2)
('total: ', 0)

和等于0,将三元组加入result。检查左指针指向的数(-1)是否与下一个数(0)相等,如果相等,就要跳过重复的左指针元素;同样道理,检查右指针指向的数(2)是否与前一个数(1)相等,如果相等,就跳过重复的右指针元素。

移动指针后,继续计算和。
('nums[i]: ', -1)
('nums[left]: ', 0)
('nums[right]: ', 1)
('total: ', 0)

和等于0,将三元组加入result。

左指针大于右指针,遍历结束。

('i: ', 2)

nums[2]还是 -1,因此跳过。

('i: ', 3)
('nums[i]: ', 0)
('nums[left]: ', 1)
('nums[right]: ', 2)
('total: ', 3)

左指针大于右指针,遍历结束。

('i: ', 4)
左指针等于右指针,while loop不会开始。

('i: ', 5)
左指针大于右指针,while loop不会开始。

output是 [[-1,-1,2],[-1,0,1]]

time complexity是O(n^2)

评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值